;****************************ADC 4431 Init ***************************************************************	

;    4431   .
; 10 ,  , TAD=CLC/32 TAQ=0
;   1000   1 
;   AN0
;         4 .
;    -       
; .   5 , 1     4 
; -.
;     4 
	
	ADC_Page	; BSR for ADC Task

		clrf	ADCON0,ACCESS
		bsf		ADCON0,ADON,ACCESS			;   ,  5-10 
		bsf		ADCON0,ACSCH,ACCESS	; 1 = Multi-Channel mode Enabled, Single Channel mode Disabled
		bsf		ADCON0,ACONV,ACCESS	;Auto-Conversion Continuous Loop or Single-shot Mode Select bit
		bsf		ADCON0,ACMOD0,ACCESS;01 =Sequential Mode2 (SEQM2). Four samples are taken in sequence:
;1st sample: Group A 2nd sample: Group B 3rd sample: Group C 4th sample: Group D
; Single shoot, Single channel,Single Ch Mode1 (SCM1). Group A is taken and converted 
		clrf	ADCON1,ACCESS				
; bit 7-6 VCFG<1:0>: A/D VREF+ and A/D VREF- Source Selection bits
; 00 =VREF+ = AVDD, VREF- = AVSS, (AN2 and AN3 are Analog inputs or Digital I/O)
; bit 4 FIFOEN 0 = FIFO is disabled
		bsf		ADCON1,FIFOEN,ACCESS	;1 = FIFO is enabled
 		clrf	ADCON2,ACCESS				
; bit 7 ADFM: A/D Result Format Select bit 0 = Left justified
; bit 6-3 ACQT<3:0>: A/D Acquisition Time Select bits
; 0000 = No Delay(1) (Conversion starts immediately when GO/DONE is set)

;bit 2-0 ADCS<2:0>: A/D Conversion Clock Select bits
;000 = FOSC/2 ;001 = FOSC/8 ;010 = FOSC/32
;011 = FRC/4(2) ;100 = FOSC/4 ;101 = FOSC/16
;110 = FOSC/64 ;111 = FRC (Internal A/D RC Oscillator)
;Note 1: If the A/D clock source is selected as RC, a time of TCY is added before sampling/
;conversion starts.
;2: Due to an increased frequency of the internal A/D RC oscillator, FRC/4 provides clock
;frequencies compatible with previous A/D modules.
;3: In sequential mode TACQ should be 12 TAD or greater.
;

; bit 2-0 ADCS<2:0>: A/D Conversion Clock Select bits 000 = FOSC/2 001 = FOSC/8 
; minimum TAD = 380-385 ns. 48/16=333 ,  
;  -         .
#ifdef __DEBUG;*******   
	bsf		ADCON2,ADCS2,ACCESS			; 101= TAD= CLC/16 = 2 uS
;	bsf		ADCON2,ADCS0,ACCESS			; 101= TAD= CLC/16 = 2 uS
	bsf	ADCON2,ADCS1,ACCESS	; 110 = 48/64=0.75 1333+ ns
#else
;	bsf		ADCON2,ADCS2,ACCESS			; 101= TAD= CLC/16 = 2 uS
;	bsf		ADCON2,ADCS0,ACCESS			; 101= TAD= CLC/16 = 2 uS
	bsf	ADCON2,ADCS1,ACCESS	; 010 = 48/32=1.5 600+ ns
#endif



;0001 = 2 TAD 0010 = 4 TAD 0011 = 6 TAD 0100 = 8 TAD 0101 = 10 TAD 0110 = 12 TAD
;	bsf	ADCON2,ACQT0,ACCESS	; 0001 = 2 TAD = 1.2 
;	bsf	ADCON2,ACQT1,ACCESS	; 0010 = 4 TAD = 2.4 
;	bsf	ADCON2,ACQT2,ACCESS	; ACQ= 100 = 8*TAD= 16 uS
	bsf	ADCON2,ACQT3,ACCESS	; ACQ= 1000 = 20*TAD= 16 uS
;  20-12    (2.4 ), 20  * 32  = 640 , 2560  , 18750  
; 
;      -     - ACQT0-3        
;  ,      .     :
;3: In sequential mode TACQ should be 12 TAD or greater.
; 75    , 18750  , 293   
; -       20     32   .
;  18750    10 -   1/10         .
; 1/100     ,      - 
; 1/1000       ,      - .
;03/04/2018 -       40-64 TAD ( 258 EQUATION 21-3: CONVERSION TIME FOR MULTI-CHANNEL MODES)
;Sequential Mode:T = (TACQ)A + (TCON)A + [(TACQ)B  12 TAD] + (TCON)B + [(TACQ)C  12 TAD] + (TCON)C + [(TACQ)D  12 TAD] + (TCON)D
;Simultaneous Mode:T = TACQ + (TCON)A + (TCON)B + TACQ + (TCON)C + (TCON)D

;0001 = 2 TAD	448		26785.71429		418.5267857
;0010 = 4 TAD	512		23437.5		366.2109375
;0011 = 6 TAD	576		20833.33333		325.5208333
;0100 = 8 TAD	640		18750			292.96875
;0101 = 10 TAD	704		17045.45455		266.3352273
;0110 = 12 TAD	768		15625			244.140625
; 		31 250  -       
;0111 = 16 TAD	896		13392.85714		209.2633929
;; 	23 437,5  -       
;1000 = 20 TAD	1024	11718.75		183.1054688
;1000 = 20-12 TAD 640	18 750 		292.96875 - 
;1001 = 24 TAD	1152	10416.66667		162.7604167
;1010 = 28 TAD	1280	9375			146.484375	; 26 785.714  Simultaneous Mode
;1011 = 32 TAD	1408	8522.727273		133.1676136	; 23 437.500  Simultaneous Mode
;1100 = 36 TAD	1536	7812.5			122.0703125	; 20 833.333  Simultaneous Mode
;1101 = 40 TAD	1664	7211.538462		112.6802885	; 18 750  Simultaneous Mode
;1110 = 48 TAD	1920	6250			97.65625	; 15 625  Simultaneous Mode
;1111 = 64 TAD	2432	4934.210526		77.09703947	; 11 718.750  Simultaneous Mode
;    16 /64   -    ?

	bsf	ADCON2,ADFM,ACCESS	; bit 7 ADFM: A/D Result Format Select bit 0 = Left justified
			;     010 = FOSC/32
;	bsf		ADCON2,ADCS0,ACCESS			; 
;	bsf		ADCON2,ACQT2,ACCESS			; ACQ= 100 = 8*TAD= 16 uS
;	bcf		ADCON2,ACQT1,ACCESS			;   
;	bcf		ADCON2,ACQT0,ACCESS			;  


 		clrf	ADCON3,ACCESS			;
;ADRS=00 (int on each word) , SSRC=0000	(all triggers disabled)
	bsf		ADCON3,ADRS1,ACCESS			; 10 =Interrupt is generated when the 4th word is written to the buffer

		setf	ANSEL0,ACCESS		; PortA -   
		setf	ANSEL1,ACCESS		; AN8 =  
		setf	TRISA,ACCESS		; PortA =  
;		bcf		TRISA,RA4,ACCESS	; AN4 = RA4 = Digital Input
		setf	TRISE,ACCESS		; PortE =  

	bcf		ANSEL0,ANS4,ACCESS	; AN4 = RA4 = Digital Input
;	bsf		ANSEL0,ANS1,ACCESS	; AN1 = RA1 = Analog Input
#ifdef __DEBUG;*******  
	bcf		ANSEL0,ANS6,ACCESS	; AN6 = RE0 = Digital Input
	bcf		ANSEL0,ANS7,ACCESS	; AN7 = RE1 = Digital Input
	clrf	ANSEL1,ACCESS		; AN8 = RE2 = Digital Input
#endif
;	bsf		ANSEL0,ANS6,ACCESS	; AN6 = RE0 = Analog
;	bsf		ANSEL0,ANS7,ACCESS	; AN7 = RE1 = Analog

 		clrf	ADCHS,ACCESS			;  8  - 2   4 ,
;   RA4/AN4/Cap3/QEB
;GDSEL=00=AN3, GBSEL=00=AN1, GCSEL=00=AN2, GASEL=00=AN0
;     /  2--3-4  .
;     0 (  8),   1  5,       6  7.
;	bsf		ADCHS,GDSEL0,ACCESS			; = 01 =AN7(1) 
;	bsf		ADCHS,GCSEL0,ACCESS			; = 01 =AN6(1) 


	bsf		ADCON0,ADON,ACCESS		;  
	;   
		bcf		IPR1,ADIP,ACCESS	;  /
	bcf		PIR1,ADIF,ACCESS		;   
	bsf		PIE1,ADIE,ACCESS		;   - 
	bsf		ADCON0,GO_DONE,ACCESS	;    
;            
	movlf	.32,ADC_Counter,BANKED	;   
	movlf	.64,ADC_Counter2,BANKED	;   
	clrf	ADC_ERR_Counter,ACCESS			;
	clrf_N	ADC_Buff+0x0,BANKED,0xF	; 
;	clrf	ADC_Buff+0x1,BANKED	;  
;	clrf	ADC_Buff+0x2,BANKED	; 
;	clrf	ADC_Buff+0x3,BANKED	;
;	clrf	ADC_Buff+0x4,BANKED	;
;	clrf	ADC_Buff+0x5,BANKED	;
;	clrf	ADC_Buff+0x6,BANKED	;
;	clrf	ADC_Buff+0x7,BANKED	;
;	clrf	ADC_Buff+0x8,BANKED	; 
;	clrf	ADC_Buff+0x9,BANKED	;  
;	clrf	ADC_Buff+0xA,BANKED	; 
;	clrf	ADC_Buff+0xB,BANKED	;
;	clrf	ADC_Buff+0xC,BANKED	;
;	clrf	ADC_Buff+0xD,BANKED	;
;	clrf	ADC_Buff+0xE,BANKED	;
;	clrf	ADC_Buff+0xF,BANKED	;
;

