;******************************************************************************
;    Filename: Main_Module.Asm                                                   *
;    Date:                                                                    *
;    File Version: 000.001                                                    *
;    Author: PSW.RU                                                           *
;    Company: Labs                                                            *
;******************************************************************************
;                                                                             *
;    Files required:         P18F4431.INC, Pic18_M.INC,LCD_Text.asm           *
;                                                                             *
;******************************************************************************
;   Proj_Dir    :
	#include Define.inc	;     
 
;;   -      Define	

;******************************************************************************
;
;Configuration bits
;    CONFIG	OSC = HS,FCMEN=OFF,IESO=OFF        	  ;IRCIO
    CONFIG	OSC = HSPLL,FCMEN=ON,IESO=ON;FF        	  ;12-48 MHz
;    CONFIG	OSC = IRCIO,FCMEN=OFF,IESO=OFF        ;LP
	CONFIG	PWRTEN=OFF,BOREN=ON,BORV=27	;

;	CONFIG	WDTEN=ON,WINEN=OFF,WDPS=1	;  , ,   4  
 #ifndef	__DEBUG_
	CONFIG	WDTEN=OFF,WINEN=OFF,WDPS=1	;     -  .
 #else
	CONFIG	WDTEN=ON,WINEN=OFF,WDPS=1	;  , ,   4  
 #endif

 #ifdef	PCPWM_Present
 	CONFIG	PWMPIN=ON;OFF;   PCPWM 
	CONFIG	LPOL=LOW,HPOL=LOW ;HIGH;    -   
;   Independent mode.   IRAMX     .
;      -     .
 #else
 	CONFIG	PWMPIN=OFF;   PCPWM 
 endif
;	CONFIG	,GPTREN=ON

	CONFIG	FLTAMX=RD4,PWM4MX=RB5,SSPMX=RD1
	CONFIG	EXCLKMX=RC3,STVREN=ON
	CONFIG	MCLRE=ON;  
	CONFIG	LVP=OFF,DEBUG=ON;OFF
;******************************************************************************
EEPROM_data code_pack 0xf00000 ;   
; Data to be programmed into the Data EEPROM is defined here
;        :
; 1.       Proj_Dir\1W\DefVar1_1W.inc
; 2.  /    Proj_Dir\EPROM\EPROM_RegsAdr.inc
; 3.      
;         Proj_Dir\EPROM\EPROM_RegsAdr.inc.
; 4.  ParametrNum   Proj_Dir\LCD_Key_Enc\Define_LCD_Key_Enc.inc
; 5.           
;   Proj_Dir\LCD_Key_Enc\LCD_Enc_Text.inc     
; 6.      , 
;Proj_Dir\LCD_Key_Enc\Int_Encoder.inc  : movlw d'3';      "Accelerate"

#ifdef PCPWM_Board ;       

	#ifdef	W1_Pin
	DE	0x1D;00  Par_K
	DE	0x22;00  Par_K1
	#endif
	#ifdef PCPWM_Present
	DE	0xD7;00  Par_T
	DE	0xCA;00   Par_A
	DE	0xE0;00    Par_V
	DE	0xA0;00    Par_UV
    #endif
#else ;       - , , 

	#ifdef	W1_Pin
	DE	0x1D;00  Par_K
	DE	0x22;00  Par_K1
	#endif
	#ifdef PCPWM_Present
	DE	0x58;00  Par_T
	DE	0xFA;00   Par_A
	DE	0xFA;00    Par_V
	DE	0x88;00    Par_UV
    #endif
#endif
	#ifdef PCPWM_Present
	DE	0xA0;01  PCPWM_Speed
	DE	0x40;02  PCPWM_Speed_M0
	DE	0xC0;03  PCPWM_Speed_M1

;   MaxSpdIndex     MaxSpdIndex > 3 :
;0x13=5K 0x27=10K 4E=20K 0x76=30K 0x9D=40K 0xC4=50K 0xEC=60K 0xFF=65K

;      :
;	DE	d'00';0x10;10 PCPWM_MaxSpdIndx; 0=100  ,      .
;	DE	0xBB;01 PCPWM_Amp
;	DE	0x46;02 PCPWM_VFStart
;	DE	0x1;07 DelayCuriosityIndex
;	DE	0x27;03 PCPWM_Accelerate    .
;   07 Over Current = 78 -     /  
;        - .
 
;      400  2.2  220  :
;	DE	d'03';0x10;10 PCPWM_MaxSpdIndx; 3=800  ,   400 .
;	DE	0x93;01 PCPWM_Amp -  ,      18-24
;	DE	0x06;02 PCPWM_VFStart -   -     .
;	DE	0x1;07 DelayCuriosityIndex
;	DE	0xFF;03 PCPWM_Accelerate    .
;   07 Over Current = F8;

;     1.5  4  220  ,      :  
	DE	d'00';0x10;04 PCPWM_MaxSpdIndx; 0=100  ,      .
	DE	0xA0;05 PCPWM_Amp
	DE	0x23;06 PCPWM_VFStart
	DE	0x1;07 DelayCuriosityIndex
	DE	0x40;08 PCPWM_Accelerate    .
	#endif

	DE	d'43';0x22;09 LCD_6_4	;    4   6
	DE	0x18;0a  
	DE	0x19;0b  
	DE	0x20;0c  
	DE	0x21;0d  
	DE	0x22;0e  
	DE	0x23;0f  
	DE	0x24;  
	DE	0x25;  
	DE	0x26;  
	DE	0x0A; LCD_DebounceTimeOut 
	DE	0x28;  
	DE	0x29;  
	DE	0x2A;  
	DE	0x2B;  
	DE	0x2C;  
	DE	0x2D;  
;      -      
;  ,  /,    
;******************************************************************************
;	extern	MsgI,Write_LCD,Read_LCD_BF,Read_LCD,LCD_Task,StepTask,EePROM_Sync,W1_Task
	
;	extern	TestCRC,KeyboardRead;
;	EXTERN	FXD1608U

	global	InitAll,CaseGoTo,CaseBra;::BIN_2_BCD,
;

;Reset vector
; This code will start executing when a reset occurs.
 ;extern	LowInt	,HighInt;,
RST		code	0x0000
RST
	bsf	OSCCON,IRCF2,ACCESS	;    RC  4  
;bra RST	;      PCPWM   RESET

;		movff	RCON,RCON_Print	; Copy RCON for LCD
		goto	InitAll		;go to start of main code
;HiInt	code	0x0008
;		bra	HighInt		;go to high priority interrupt routine
;LoInt	code	0x0018
;		goto	LowInt		;go to low priority interrupt routine

Main_L	code	;0x0000

; #include P_D\Interrupt_3F.inc	;     	
; MainLoop	code ;     


;******************************************************************************
; Start of main program
InitAll:
	movlf	b'01110000',OSCCON,ACCESS	;   8  
 #ifdef	PCPWM_Present
; IRAMX       
	bsf		LATA,1,ACCESS	;  
	bcf		TRISA,1,ACCESS	;    
 #endif
;#ifdef __DEBUG
;	bsf Math_Flag,0,ACCESS	;   
;;0= /     MainLoop	
;	bcf	RevCalc_Flag,0,BANKED;    
;	clrf Math_Cmd,ACCESS	;   0 
;	bsf Math_Flag,0,ACCESS	;   
;	;btfsc	PCPWM_Flag,7,ACCESS	;   ?
; bra	MainLoop
;#endif
		movff	RCON,RCON_Print	; Copy RCON for LCD and analize
;    RCON       - 
;   1 ( ) 0F ( ) 0E ( ) 07 (WDT TimeOut) .
; ;bra InitAll ;    PCPWM  RESET
	bsf		RCON,IPEN,ACCESS		;   
	bcf		RCON,NOT_RI,ACCESS		; RESET  
	bsf		RCON,NOT_POR,ACCESS		; 
	bsf		RCON,NOT_BOR,ACCESS		; , BOR   

	DefaultBankSelect	;   
 #include Proj_Dir\_Out\Init_All.inc	;      .
	bsf		INTCON,GIEH,ACCESS		;    	
	bsf		INTCON,GIEL,ACCESS		;    
;	bsf		ADCON0,GO_DONE,ACCESS	;    
#ifndef	__DEBUG
	bsf		WDTCON,SWDTEN,ACCESS	;	 
#endif
	clrf	WDT_Counter,ACCESS	;   
	clrf	WDT_Flag,ACCESS	;   
		bra WDT_Init;    
MainLoop:
; #ifdef __DEBUG
;	 bra TestLoop
; endif
;		clrwdt ;  4  - ,  4+ 

	dcfsnz	WDT_Counter,F,ACCESS;    MainLoop
		bcf	WDT_Flag,2,ACCESS	;    MainLoop
 	;incfsz	WDT_Counter,F,ACCESS;    256 - 
	btfsc	WDT_Flag,0,ACCESS	;      ADC 
		bra	Done_WDT
	movf	WDT_Flag,W,ACCESS	;        ?
		bnz	Done_WDT
WDT_Init:
	movlf	d'30',WDT_ADC,ACCESS;     ADC  18 750/250 
;	movlf	d'46',WDT_PWM,ACCESS;    PWM  11 718.75/250 
	movlf	d'2',WDT_Counter,ACCESS;   Main_Loop  
	bsf	WDT_Flag,0,ACCESS	;    ADC
	;bsf	WDT_Flag,1,ACCESS	;    PWM
	bsf	WDT_Flag,2,ACCESS	;    Main_Loop
		clrwdt ;  4  - ,  4+ 
Done_WDT:
;
	DefaultBankSelect	;   		
; The main program LOOP code is placed here.
 #include Proj_Dir\_Out\MLTask_All.inc	;     .
; 
 bra MainLoop
;       -    ?
CaseGoTo:	;;  - WREG
; K8LH RE: PIC18F4331: COMPUTED GOTO! Thursday, August 17, 2006 8:22 AM (permalink)
;http://www.microchip.com/forums/m182713.aspx javascript:void(showMsgNum(182838))
	bcf	_C	;       
		rlncf   WREG,F,ACCESS   ;  
CaseBra:	;   -  
		rlncf   WREG,F,ACCESS   ;
	bcf	WREG,0,ACCESS	;      
	addwf   TOSL,f,ACCESS ;  
	movlw   0x0           ; 
	addwfc  TOSH,f,ACCESS ; 
;addwfc  TOSU,f,ACCESS;  for > 64-kbyte memory
	return;       WREG
;End of program
		END
